/*******************************************************************

  XPUYO   puyo-puyo for X11          (c)1997 CDR/TK  (Tatsuya Kudoh)

  graph.c ---- low-level graphical handling

  ॰եå

    x,y : 饯ñ̤κɸ夬(20)
    col : פο0Ϥפʳ (طʡɡƩפ)
    form: פηcol==0λϥ饯μ

*******************************************************************/


#include<stdio.h>
#include<X11/Xlib.h>
#include"xpuyo.h"
#include"xpuyo_x11.h"

static int Map[8][15];   /* ۲         */
static int Change_flag;  /* ̹뤫 */



/* ɥ֥˥饯衣ºݤ褷 1⤷ʤ 0 ֤*/
/* x,yޥʥޤϥɥ֥礭ư                  */

static int copy_graph( Drawable drw, int x, int y, int col, int form )
{
  int sy;

  sy = form * 32;

  x *= 32;
  y = (y-2) * 32;

  if( y < 0 )
    return 0;

  XCopyArea( Disp,Graph[0],drw,Gc_nomask,0,0,32,32,x,y );

  if( col > 0 || form > 0 ){
    XSetClipOrigin( Disp,Gc_mask[col],x,y-sy );
    XCopyArea( Disp,Graph[col],drw,Gc_mask[col],0,sy,32,32,x,y );
  }
  return 1;
}



/* ۲̤񤭴롣Ѳʤ 0 ֤ */

static int change( int x, int y, int col, int form )
{
  form += col * 256;
  if( Map[x][y] == form )
    return 0;
  Map[x][y] = form;
  return 1;
}



/* ΢̤˥饯衣Ѳʤ 0 ֤*/

int set_graph( int x, int y, int col, int form )
{

  if( change( x,y,col,form ) && copy_graph( Scr_p,x,y,col,form ) ){
    Change_flag = 1;
    return 1;
  }else
    return 0;
}



/* 饯 */

void put_graph( int x, int y, int col, int form )
{
  if( change( x,y,col,form ) && copy_graph( Scr_p,x,y,col,form ) ){
    x *= 32;
    y = (y-2)*32;
    XCopyArea( Disp,Scr_p,Scr_w,Gc_nomask,x,y,32,32,x,y );
  }
}



/* ΢̡۲̤ν */

void clear_screen( void )
{
  int x,y;

  for( y = 2 ; y < 15 ; y++ )
    for( x = 0 ; x < 8 ; x++ ){
      Map[x][y] = -1;
      set_graph( x,y,0,1 );
    }

  for( y = 2 ; y < 6 ; y++ )
    for( x = 0 ; x < 3 ; x++ )
      copy_graph( Next_p,x,y,0,1 );

  Change_flag = 1;
}



/* NEXTפɽ */

void put_next( int col1, int col2 )
{
  copy_graph( Next_p,1,4,col1,0 );
  copy_graph( Next_p,1,3,col2,16 );

  XCopyArea( Disp,Next_p,Next_w,Gc_nomask,32,32,32,64,32,32 );
}



/* ΢̤¸ (Ѥ˻Ȥ) */

void save_scr( void )
{
  XCopyArea( Disp,Scr_p,Scr_sp,Gc_nomask,0,0,256,416,0,0 );
}



/* ǡ 0 λsave_scr¸եå  */
/*              1 λ΢̤ɽ                  */

void blink( int i )
{
  if( i )
    XCopyArea( Disp,Scr_p,Scr_w,Gc_nomask,0,0,256,416,0,0 );
  else
    XCopyArea( Disp,Scr_sp,Scr_w,Gc_nomask,0,0,256,416,0,0 );
}



/* ̹ (΢̤ɽ) */

void flush_scr( void )
{
  if( Change_flag ){
    XCopyArea( Disp,Scr_p,Scr_w,Gc_nomask,0,0,256,416,0,0 );
    Change_flag = 0;
  }
}
